\documentclass[sigconf]{acmart}

\usepackage{booktabs}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{listings}
\usepackage{array}
\usepackage{multirow}
\usepackage{multicol}
\usepackage{xspace}
\usepackage{xcolor}
\newlength{\Oldarrayrulewidth}
\newcommand{\Cline}[2]{
  \noalign{\global\setlength{\Oldarrayrulewidth}{\arrayrulewidth}}
  \noalign{\global\setlength{\arrayrulewidth}{#1}}\cline{#2}
  \noalign{\global\setlength{\arrayrulewidth}{\Oldarrayrulewidth}}}

\newcommand{\MIPP}{\texttt{MIPP}\xspace}
\newcommand{\longMIPP}{\textsc{MyIntrinsics++}\xspace}
\newcommand{\TSIMD}{\texttt{T-SIMD}\xspace}
\newcommand{\xsimd}{\texttt{xsimd}\xspace}
\newcommand{\simdpp}{\texttt{simdpp}\xspace}
\newcommand{\Vc}{\texttt{Vc}\xspace}
\newcommand{\VCL}{\texttt{VCL}\xspace}
\newcommand{\BoostSIMD}{\texttt{Boost.SIMD}\xspace}
\newcommand{\bSIMD}{\texttt{bSIMD}\xspace}

\newcommand{\Cxx}{\texttt{C++}\xspace}
\newcommand{\Cxy}[1]{\texttt{C++{#1}}\xspace}
\newcommand{\CppUnit}{\texttt{CppUnit}\xspace}

\setlength{\textfloatsep}{5pt}
\setlength{\parsep}{0pt}
\setlength{\parskip}{0pt}

\usepackage{pifont}
\newcommand{\cmark}{\ding{51}}
\newcommand{\xmark}{\ding{55}}
\newcommand{\Arikan}{Ar{\i}kan\xspace}

\definecolor{main-color}{rgb}{0.6627, 0.7176, 0.7764}
\definecolor{back-color}{rgb}{0.1686, 0.1686, 0.1686}
\definecolor{string-color}{rgb}{0.3333, 0.5254, 0.345}
\definecolor{key-color}{rgb}{0.8, 0.47, 0.196}
\definecolor{comment-color}{rgb}{0.35, 0.35, 0.35}

\lstdefinestyle{mycpp}
{
    language = C++,
    numbers=left,
    numbersep=0.3em,
    tabsize=2,
    basicstyle=\footnotesize\ttfamily,
    morekeywords = {constexpr,int8_t,int16_t,int32_t},
    commentstyle=\color{comment-color},
}

\copyrightyear{2018}
\acmYear{2018}
\setcopyright{othergov}
\acmConference[WPMVP'18]{Workshop on Programming Models for SIMD/Vector Processing}{February 24--28, 2018}{Vienna, Austria}
\acmBooktitle{WPMVP'18 : Workshop on Programming Models for SIMD/Vector Processing, February 24--28, 2018, Vienna, Austria}
\acmPrice{15.00}
\acmDOI{10.1145/3178433.3178435}
\acmISBN{978-1-4503-5646-6/18/02}

\begin{document}
\title{MIPP: a Portable C++ SIMD Wrapper and its use for Error Correction Coding in 5G Standard}
\renewcommand{\shorttitle}{MIPP: a Portable C++ SIMD Wrapper and its use for ECC in 5G Standard}

\author{Adrien Cassagne$^{*\dagger}$, Olivier Aumage$^{*}$,  Denis Barthou$^{*}$, Camille Leroux$^{\dagger}$ and Christophe J\'ego$^{\dagger}$}
\affiliation{%
  $\,^{*}$
  \institution{Inria, Bordeaux Institute of Technology, LaBRI/CNRS, Bordeaux, France}
}
\affiliation{%
  $\,^{\dagger}$
  \institution{IMS/CNRS, Bordeaux, France}
}
\renewcommand{\shortauthors}{A. Cassagne et al.}

\begin{abstract}

Error correction code (ECC) processing has so far been performed on
dedicated hardware for previous generations of mobile communication
standards, to meet latency and bandwidth constraints. As the 5G mobile
standard, and its associated channel coding algorithms, are now being
specified, modern CPUs are progressing to the point where software
channel decoders can viably be contemplated. A key aspect in reaching
this transition point is to get the most of CPUs SIMD units on the
decoding algorithms being pondered for 5G mobile standards. The nature
and diversity of such algorithms requires highly versatile programming
tools. This paper demonstrates the virtues and versatility of our
\emph{MIPP} SIMD wrapper in implementing a high performance portfolio of
key ECC decoding algorithms.

\end{abstract}

\keywords{SIMD, wrapper, C++, channel code, SSE, AVX, AVX-512, NEON}

\maketitle

\section{Introduction}

The standardization of the fifth generation of mobile network (5G) is
currently under discussion \cite{ETSI2017}. As any communication standard,
it will define the protocols to be used on the different abstraction
layers of a mobile network. Regarding the lower layers (PHY and MAC
layers), the standard specifies several methods and algorithms to be
applied on the digital information to be transmitted. Among them,
error correction codes and their associated encoding/decoding algorithms
represent what is called \textit{channel coding}. The purpose of this
data processing is to add redundancy to the message on the transmitter
side. On the receiver side, the decoder exploits
redundancy to detect and correct the potential errors in the
received message. Among all the PHY and MAC layer algorithms, channel
coding is the most computationally intensive. This is especially true for
the decoding algorithms on the receiver side. Moreover, channel
coding processing must be performed under stringent timing
constraints: low latency and high throughput. This explains why, in
the previous generations of mobile communication standards (4G, 3G,
...), channel coding was performed on dedicated hardware. With recent multicore
general purpose processors, it seems possible to execute channel
decoding algorithms on programmable hardware under real time
constraints. Furthermore, in the future 5G standard, this migration of
PHY and MAC layers processing from dedicated hardware to programmable
processors is pushed to such an extent that the overall network could
actually be completely virtualized. In this new paradigm, denoted as
Cloud-RAN (Radio Access Network), instead of being executed on
dedicated hardware close to the antennas, all the digital data
processing would be performed on centralized large scale programmable
processors arrays. This would allow a dynamic balancing of the
computational effort within the network \cite{Rost2014,Ericsson2015,Paul2015,Nikaein2015,Rodriguez2017}.

In this context of network virtualization, recent articles have
proposed several optimized software decoders, corresponding to
different channel codes : LDPC codes \cite{LeGal2015,LeGal2016},
polar codes \cite{Giard2016b,Sarkis2016,Cassagne2016,Cassagne2016b},
turbo codes \cite{Zhang2012,Wu2013,Cassagne2016a}.
All of these works show the possibility to reach a good level of
\textit{performance} by  making extensive use of SIMD (Single Instruction
Multiple Data) units.
This is often achieved at the price of a reduced
\textit{flexibility}, by resorting to specific intrinsics,
or by making assumptions on the data types. However, these decoders should
be implemented in a single source code, in which the following parameters could
be changed at runtime:
the channel code type,
the decoding algorithm, the number of decoding iterations, the data
format, etc. Another important aspect is the \textit{portability} of the
source code on different hardwares (Intel x86, Xeon KNL and ARM) and the possibility
to use different instruction sets (\verb|SSE|, \verb|AVX|, \verb|AVX-512|, \verb|NEON|).
These three constraints (performance, flexibility, portability) push
towards the use of a SIMD library that helps in the abstraction of the
SIMD instruction sets, while still allowing a fine grain tuning of
performance.

We propose in this paper a new  \Cxx SIMD wrapper, covering the needs in
terms of expressiveness and of performance for the channel codes. Our
contributions are:
\begin{itemize}
\item A portable and high performance  \Cxx SIMD wrapper called \MIPP, for \verb|SSE|,
  \verb|AVX|, \verb|AVX-512| and \verb|NEON| instruction sets;
\item An implementation of several channel codes with this wrapper. We
  present the main advantages of \MIPP in this context;
\item A comparison with other state-of-the-art SIMD
  wrappers on a Mandelbrot code, demonstrating that the code based on \MIPP has
  similar performance as hand-written intrinsics.
\end{itemize}
\MIPP programming model is not too far from intrinsics, allowing a good
control on performance, but still provides an abstraction on the basic
types used in vectors (ranging from double to byte) and complex
operations (parametric reductions, log, exponential, ...).

\section{Proposed Wrapper}

The \longMIPP library (\MIPP) is a portable wrapper for SIMD intrinsics
written in the \Cxx language. It relies on \Cxx compile-time template
specialization techniques to replace supported generic functions with
inline calls to their intrinsics counterpart, for a given instruction
set. While \MIPP is mostly written in \Cxy{98}, it still requires
\Cxy{11}-compliant compiler due to the use of convenient features such
as the \verb|auto| and \verb|using| keywords.
\MIPP is Open-source (under the MIT license) and the full code is available on GitHub\footnote{\MIPP source code: \url{https://github.com/aff3ct/MIPP}}.

\MIPP provides two application programming interface levels. The
\emph{Low Level Interface} (low) implements a basic, thin abstraction
layer on top of the intrinsics. The \emph{Medium Level Interface} (med.),
built on top of \MIPP low, abstracts away more details to lessen the
effort from the application programmer by relying on object
encapsulation and operator overloading.

\subsection{Low Level Interface}

\MIPP low is built around a unified \verb|mipp::reg| type that abstracts
vector registers. The vector register type represents hardware registers
independently of the data type of the vector elements. \MIPP uses the
longest native vector length available on the architecture. This design
choice preserves programmer flexibility, for instance in situations such
as mixing fixed-point and floating-point operations. \MIPP also defines
a \emph{mask} register type \verb|mipp::msk|, which either directly
maps to real hardware masks on instruction sets that support it (such as
AVX-512), or to simple vector registers otherwise.

\MIPP low then defines a set of functions working with
\verb|mipp::reg| and \verb|mipp::msk|, organized into eight
families: memory accesses, shuffles, bitwise boolean arithmetic, integer
operations, float. operations, mathematical functions, reductions, and mask
operations.

In the AVX-512 instruction set,
one \textit{regular} vector operation plus one masking operation can be
performed in one CPU clock cycle. For instance, the following
instruction performs \verb|"m ? a+b : src"|, an addition and a masking operation:
\begin{verbatim}
  __m512 _mm512_mask_add_ps(__m512 src, __mmask16 m,
                            __m512 a,   __m512    b);
\end{verbatim}
\MIPP natively supports such operations with the
\verb|mipp::mask| function. The previous example becomes in
\MIPP:
\begin{verbatim}
  mipp::mask<float,mipp::add<float>>(m, src, a, b);
\end{verbatim}
For instruction sets without masking support, the
\verb|mipp::mask| call is expanded as an operation and a
\verb|blend| instead.

\subsection{Medium Level Interface}

\begin{figure}[htp]
\begin{lstlisting}[style = mycpp, caption={Medium Level Interface encapsulation.}, label={lst:MLI}]
template <typename T>
class Reg {
  mipp::reg r; // the register type from MIPP low
  Reg(const T *ptr) : r(mipp::load<T>(ptr)) {}
  inline Reg<T> add(const Reg<T> r) const {
    return mipp::add<T>(r,r.r);
  }
  inline Reg<T> operator+(const Reg<T> r) const {
    return this->add(r);
  } /* ... */
};
\end{lstlisting}
\end{figure}

The \MIPP Medium Level Interface (\MIPP med.) provides additional expressiveness to
the programmer. \verb|mipp::reg| and \verb|mipp::msk| basic types are
encapsulated in \verb|mipp::Reg<T>| and \verb|mipp::Msk<N>| objects,
respectively. The \verb|T| and \verb|N| template parameters correspond
to the type and the number of elements inside the vector register and the mask
register, respectively. One can notice that in these register objects
are typed, unlike the \MIPP low register basic type. It avoids to write the
type when a \MIPP function is called. The function type can then be
directly selected from the parameter type. Listing~\ref{lst:MLI}
illustrates the template-based encapsulation, which enables \MIPP to
override common arithmetic and comparison operators.

\MIPP med. also simplifies register loading and initialization operations. The
constructor of the \verb|mipp::Reg| object will call the
\verb|mipp::load| function automatically. Thus, a load in \MIPP low:
\begin{verbatim}
  mipp::reg a = mipp::load<float>(aligned_ptr);
\end{verbatim}
can be simplified into:
\begin{verbatim}
  mipp::Reg<float> a = aligned_ptr;
\end{verbatim}
with \MIPP med. level. An initializer list
can be used with a \MIPP med. vector register:
\begin{verbatim}
  mipp::Reg<float> a = {1.f, 2.f, 3.f, 4.f};
\end{verbatim}
Likewise, a scalar assigned to a vector sets all elements to
this value.

\subsection{Implementation Details}
\label{subsec:implem}

\MIPP targets \verb|SSE2|,
\verb|SSE3|, \verb|SSSE3|, \verb|SSE4.1|, \verb|SSE4.2|, \verb|AVX|,
\verb|AVX2|, \verb|FMA3|, \verb|KNCI|, \verb|AVX-512F| and \verb|AVX-512BW|
instruction sets on x86 and related architectures, as well as \verb|NEON|, \verb|NEONv2|,
\verb|NEON64| and \verb|NEON64v2| on ARM. It can
easily be extended to other instruction sets.

\MIPP selects the most recent instruction set available at compile time.
For instance, a code compiled with the \verb|-march=avx| flag of the
GNU GCC compiler uses \verb|AVX| instructions even if the architecture
supports \verb|SSE| as well. The vector register size is
determined by the instruction set and the data type. A dedicated
function returns the number of elements in a \MIPP register:
\begin{verbatim}
  constexpr int n = mipp::nElmtsPerRegister<T>();
\end{verbatim}
A shortened version is also defined
as: \verb|mipp::N<T>()|. Whenever vectorization takes place in loops, \MIPP's
philosophy is to change the stride of the loop from one to the size of
registers. The stride can be statically determined with the \verb|mipp::N<T>()|
function.
If the loop size is not a multiple of the registers size, 1) a
sequential tail loop
can be implemented to compute the remaining elements, 2) the padding technique
can be implemented to force the loop size to be a multiple of the vector
registers.

When the instruction set cannot be determined, \MIPP med. falls back on
sequential instructions. In
this case, \MIPP does not use any intrinsic  anymore. However, the
compiler vectorizer still remains effective. This mode
can also be selected by the programmer with the
\verb|MIPP_NO_INTRINSICS| macro.

\MIPP supports the following data types: \verb|double|, \verb|float|,
\verb|int64_t|, \verb|int32_t|, \verb|int16_t| and \verb|int8_t|.
It also supplies an aligned memory allocator, to be used with types such
as the \verb|std::vector<T,A>| vector container from the \Cxx standard
library (where \verb|T| is the vector element type and \verb|A| the
allocator). The alignment requirements are not guaranteed by the default \Cxx
memory allocator. The \MIPP memory allocator can be used as follows:
\begin{verbatim}
  std::vector<T,mipp::allocator> aligned_data;
\end{verbatim}
and shortened like this: \verb|mipp::vector<T>|.

\MIPP comes with a comprehensive unitary test suite to validate new
instruction set ports and new feature implementations. It has
successfully been tested with the following minimum compiler versions:
\verb|g++-4.8|, \verb|clang++-3.6|, \verb|icpc15| and \verb|msvc14.0|.

\MIPP implements a generic reduction operator based on a reduction tree,
which would be tedious to write by the application programmer, due to
the sequence of heterogeneous shuffle instructions it implies.
The computational complexity of this algorithm is $O(\log_2(N))$, with $N$ the
number of elements in a register. It can operate on
\verb|mipp::reg|, \verb|mipp::Reg<T>| and \verb|std::vector<T>|. It can
also work on dynamically allocated arrays, provided the length of the
array is a multiple of the vector register size.
Since the function passed to the reduction operator is resolved at the
compile time, the code remains efficient.
Any function with the following prototype can be used as the reduction
function:
\begin{verbatim}
  mipp::Reg<T> func(mipp::Reg<T>, mipp::Reg<T>)
\end{verbatim}
E.g., the code below computes the smallest element in a register:
\begin{verbatim}
  mipp::Reg<float> r = {4.f, 2.f, 1.f, 3.f};
  float min = mipp::Reduction<mipp::min>::sapply(r);
\end{verbatim}
The \verb|min| scalar variable will be assigned \verb|1.f| as the
result. For convenience, a set of functions is predefined, based on
this generic reduction feature: \verb|hadd|, \verb|hsub|, \verb|hmul|
and \verb|hdiv|.

\section{Error Correction Coding in 5G}

It is now viable to implement channel coding algorithms on programmable
processors under real time constraints. This kind of optimized software
implementation could be used in some scenarios of the future 5G mobile
communication standards.
Beside the real time implementation, it is also necessary to predict the error
correction capability of a channel code. To this end, the classical method is
to use Monte Carlo simulations in which noise samples are added to the coded
data in such a way that one can estimate the residual bit error rate after the
channel decoding process. The generation of uncorrelated random data is a
computationally intensive task and also requires optimization.
In this section, we present several algorithms that will be used in future 5G
communication systems together with a random sample generation algorithm and a
quantizer used for simulation of communication systems. For each algorithm, a
description of the \MIPP-optimized implementation is provided. Some speedup
measurements are given for different instruction sets. All the source codes are
implemented in AFF3CT\footnote{AFF3CT source code: \url{https://github.com/aff3ct/aff3ct}},
an Open-source library dedicated to the channel coding.

\subsection{Experimentation Protocol}
\begin{table}[htp]
  \tabcolsep=6pt
  \centering
  \caption{Specifications of the target processors.}
  \label{tab:targets}
  {\small\resizebox{\linewidth}{!}{
  \begin{tabular}{c|c|c|c|c}
  \textbf{Name}                   & \textbf{Exynos5422} & \textbf{RK3399} & \textbf{Core i5-5300U}     & \textbf{Xeon Phi 7230} \\ \hline
  \textbf{Year}                   & 2014                & 2016            & 2015                       & 2016                   \\ \hline
  \textbf{Vendor}                 & Samsung             & Rockchip        & Intel                      & Intel                  \\ \hline
  \multirow{2}{*}{\textbf{Arch.}} & ARMv7               & ARMv8           & \multirow{2}{*}{Broadwell} & Knights                \\
                                  & Cortex A15          & Cortex A72      &                            & Landing                \\ \hline
  \textbf{Cores/Freq.}            & 4/2.0 GHz           & 2/1.6 GHz       & 2/2.3 GHz                  & 64/1.3 GHz             \\ \hline
  \textbf{LLC}                    & 2 MB L2             & 1 MB L2         & 3 MB L3                    & 32MB L2                \\ \hline
  \textbf{TDP}                    & $\sim$4 W           & $\sim$2 W       & 15 W                       & 215 W                  \\
  \end{tabular}
  }}
\end{table}
Four architectures are considered for performance results, summarized
in Table~\ref{tab:targets}.
The Cortex A15 is used to evaluate the \verb|NEON| instruction set in 32-bit.
The Cortex A72 is used to evaluate the 64-bit \verb|NEON| instructions for Figure~\ref{fig:fractal}.
The Core i5 is used for both \verb|SSE| and \verb|AVX| benchmarks.
The Xeon Phi is used for \verb|AVX-512| instructions.
Source codes are compiled with the GNU \Cxx~5 compiler using
the common flags: \verb|-O3| \verb|-funroll-loops|.
The additional architecture specific flags are:
1) \verb|-march=armv7-a| \verb|-mfpu=neon-vfpv4| on Cortex A15,
2) \verb|-march=armv8-a| on Cortex A72,
3) \verb|-msse4.2| for \verb|SSE| or \verb|-mavx2 -mfma| for \verb|AVX| on Core i5,
4) \verb|-mavx512f| \verb|-mfma| on Xeon Phi.
All experiments have been performed in single-threaded. All studied problem sizes fit into the last level cache (LLC) of CPUs.
The references for the speedup computations are always sequential versions of the SIMD codes.
Those reference versions can be auto-vectorized by the compiler, thus
a reference version is compiled for each SIMD instruction set.

\subsection{Box-Muller Transform}\label{subsec:bmt}

Monte Carlo simulations of digital communication systems provide an empirical
way to evaluate error correction performance of the system. In this kind of
simulations, the channel is modeled as a white Gaussian
noise added to the encoded data. This noise generation can be split in two
parts: 1) the uniformly-distributed random variable generation, 2) the
transformation to a Gaussian random variable.
An uniform noise can be generated by a pseudo random number generator (PRNG)
like the Mersenne Twister 19937 (MT19937).
Then, the Box-Muller method~\cite{Box1958} transforms uniformly distributed
random numbers into normally distributed random numbers.

Suppose $U_1$ and $U_2$ are independent random variables uniformly distributed in $]0, 1]$:
\begin{equation*}
  z_1 = \sqrt{-2 \log{U_1}}.\cos(2\pi.U_2)),~z_2 = \sqrt{-2 \log{U_1}}.\sin(2\pi.U_2)).
\end{equation*}
Then, $z_1$ and $z_2$ are independent and normally distributed samples.

\begin{figure}[hbp]
\begin{lstlisting}[style = mycpp, caption={Box-Muller Transform MIPP kernel.}, label={lst:boxmuller}]
void BoxMullerTransform(const std::vector<float> &uniRand
                              std::vector<float> &norRand) {
	constexpr auto N = mipp::N<float>();
	const auto nElmts = uniRand.size();
	const auto twoPi = 2.f * 3.141592f;
	for (auto i = 0; i < nElmts; i += N * 2) {
		const auto u1 = mipp::Reg<float>(&uniRand[   i]);
		const auto u2 = mipp::Reg<float>(&uniRand[N +i]);
		const auto radius = mipp::sqrt(mipp::log(u1) * -2.f);
		const auto theta  = u2 * twoPi;
		mipp::Reg<float> sintheta, costheta;
		mipp::sincos(theta, sintheta, costheta);
		auto z1 = radius * costheta;
		auto z2 = radius * sintheta;
		z1.store(&norRand[   i]);
		z2.store(&norRand[N +i]);
}	}
\end{lstlisting}
\end{figure}

Listing~\ref{lst:boxmuller} presents a \MIPP implementation of the Box-Muller
transform.
\verb|uniRand| is a vector of independent and uniformly distributed random
numbers (for instance generated with the MT19937 PRNG).
\verb|norRand| is a vector of independent and normally distributed random
numbers.
The code stresses SIMD units with multiplications, \verb|mipp::sqrt| and
\verb|mipp::sincos| calls.

\begin{table}[htp]
  \tabcolsep=6pt
  \centering
  \caption{AWGN channel with \MIPP.}
  \label{tab:sp_awgn}
  {\small
  \begin{tabular}{r|r|r|r|r}
                      & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} & \textbf{\texttt{AVX-512}} \\ \hline
  \textbf{SIMD size}  & 4                      & 4                     & 8                     & 16                        \\ \hline
  \textbf{T/P} (Mb/s) & 40.9                   & 107.4                 & 178.3                 & 95.1                      \\ \hline
  \textbf{Speedup}    & $\times 3.1$           & $\times 2.3$          & $\times 4.2$          & $\times 14.4$             \\
  \end{tabular}
  }
\end{table}

The \MIPP wrapper helps to write a readable code without sacrificing the
performance. It also gives the opportunity to compile this same source code for
various architectures.
Table~\ref{tab:sp_awgn} presents the measured speedups with the same \MIPP
 code compiled for \verb|NEON|, \verb|SSE|, \verb|AVX| and
 \verb|AVX-512|, compared to the sequential code
(can be auto-vectorized).
It also shows the actual throughput (T/P) for each instruction set.
The conversion of floating-point format from single precision to double
precision only requires to replace the \verb|float| keyword by
\verb|double|. The ability to switch seamlessly from one data type to another
is clearly a strength of the \MIPP library.
In the source code of the AFF3CT library, the register type is based on a
generic type name \verb|T| (\verb|mipp::Reg<T>|).
This way the same source code can work on \verb|float| or on \verb|double|
data types.

\subsection{Quantizer}

During the implementation of ECC decoders, a common step is to convert the
floating-point representation into a fixed-point representation.
This is necessary after the reception of the noisy channel information
representing \textit{Logarithmic Likelihood Ratios} (LLRs) and encoded
as real values.
The reduction of the LLRs precision (from 32 bits floating-point to 16 or 8
bits fixed-point) does not
significantly affect error correction performance and provides more SIMD
parallelism. The quantizer computes:
\begin{equation*}
y_{s,v} = \min(\max(2^v . y \pm 0.5, -2^{s-1} +1), 2^{s-1} -1),
\end{equation*}
with $y$ the current floating-point value, $s$ the number of bits of the
quantized number, including $v$ bits for the fractional part.

\begin{table}[hbp]
  \tabcolsep=6pt
  \centering
  \caption{Quantizer speedups with \MIPP.}
  \label{tab:sp_quantizer}
  {\small
  \begin{tabular}{r|r|r|r}
                      & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
  \textbf{SIMD size}  & 4-16                   & 4-16                  & 8-32                  \\ \hline
  \textbf{T/P} (Mb/s) & 300.6                  & 3541.4                & 5628.3                \\ \hline
  \textbf{Speedup}    & $\times 4.6$           & $\times 15.6$         & $\times 25.8$         \\
  \end{tabular}
  }
\end{table}

\begin{figure}[htp]
\begin{lstlisting}[style = mycpp, caption={Sequential implementation of the quantizer.}, label={lst:seqquantizer}]
void scalarQuantizer(const std::vector<float > &Y1,
                           std::vector<int8_t> &Y2,
                     const unsigned s, const unsigned v) {
	const auto  K = Y1.size();
	const float factor = 1 << v;
	const float qMax = (1 << (s-2)) + (1 << (s-2)) -1;
	const float qMin = -qMax;
	for (auto k = 0; k < K; k++) {
		// q = 2^v * y +- 0.5
		float q = std::round(factor * Y1[k]);
		// saturation
		Y2[k] = (int8_t)std::min(std::max(q, qMin), qMax);
}	}
\end{lstlisting}
\end{figure}

\begin{figure}[htp]
\begin{lstlisting}[style = mycpp, caption={SIMD implementation of the quantizer.}, label={lst:simdquantizer}]
void SIMDQuantizer(const std::vector<float > &Y1,
                         std::vector<int8_t> &Y2,
                   const unsigned s, const unsigned v) {
	constexpr auto N = mipp::nElReg<float>();
	const auto K = Y1.size();
	const auto factor = mipp::Reg<float>(1 << v);
	const float qMax = (1 << (s-2)) + (1 << (s-2)) -1;
	const float qMin = -qMax;
	for (auto k = 0; k < K; k += 4 * N) {
		// implicit loads and q = 2^v * y +- 0.5
		auto q32_0 = mipp::round(factor * &Y1[k + 0*N]);
		auto q32_1 = mipp::round(factor * &Y1[k + 1*N]);
		auto q32_2 = mipp::round(factor * &Y1[k + 2*N]);
		auto q32_3 = mipp::round(factor * &Y1[k + 3*N]);
		// convert float to int32_t
		auto q32i_0 = mipp::cvt<int32_t>(q32_0);
		auto q32i_1 = mipp::cvt<int32_t>(q32_1);
		auto q32i_2 = mipp::cvt<int32_t>(q32_2);
		auto q32i_3 = mipp::cvt<int32_t>(q32_3);
		// pack four int32_t in two int16_t
		auto q16i_0 = mipp::pack<int32_t,int16_t>(q32i_0, q32i_1);
		auto q16i_1 = mipp::pack<int32_t,int16_t>(q32i_2, q32i_3);
		// pack two int16_t in one int8_t
		auto q8i = mipp::pack<int16_t,int8_t>(q16i_0, q16i_1);
		// saturation
		auto q8is = mipp::sat(q8i, qMin, qMax);
		q8is.store(&Y2[k]);
}	}
\end{lstlisting}
\end{figure}

The associate sequential code is presented in Listing~\ref{lst:seqquantizer}.
The code converts \verb|float| (32-bit floating-point number) to \verb|int8_t|
(8-bit signed integer).
Although the scalar code is fairlty simple, the compiler fails to auto-vectorize the
\verb|for-loop|.
\MIPP allows to convert floating-point data types to integers with the
\verb|mipp::cvt| function.
It also compresses larger data types into shorter ones with the
\verb|mipp::pack| function.
The \MIPP code is presented in Listing~\ref{lst:simdquantizer}.
It performs explicit data types packaging, while in the sequential code, this
operation is done implicitly by the \verb|(int8_t)| cast.
Table~\ref{tab:sp_quantizer} presents the obtained speedups with \MIPP.
For this specific case study the speedups are significant for \verb|SSE| and \verb|AVX|.
They are less important with the \verb|NEON| instruction set but still non-negligible.
We do not provide results for \verb|AVX-512|, since an \verb|AVX-512BW| compatible CPU would
be required and the Xeon Phi is not.

\subsection{LDPC Codes Decoding}

LDPC codes is a family of channel codes that is well spread in current digital
communication systems. They have been chosen in many communication standards
(Wifi, WiMAX, DVB-S2, 10Gbps Ethernet, etc.). They were also selected for the
future 5G standard data transport.

\begin{figure}[htp]
\centering
\includegraphics[width=0.40\textwidth]{figs/ldpc_tanner_graph}
\caption{Tanner graph of a simple parity check $H$ matrix}
\label{fig:LDPC}
\end{figure}

In this section the Min-Sum decoder for LDPC codes is presented.
As shown in Figure~\ref{fig:LDPC}, an LDPC code can be represented in the form
of a Tanner graph. The circles, denoted as variable nodes, represent the LLRs
(the noisy estimation of the bits in the received frames). The squares, denoted
as parity check nodes, represent the parity constraints that the variable nodes
have to verify.
For instance, the check node $a$ ($CN_a$) is connected to the variable
nodes $1$, $4$, $5$, $7$ and $8$ ($VN_1, VN_4, VN_5, VN_7, VN_8$).
It means that the corresponding bits $U_1, U_4, U_5, U_7, U_8$ have to respect
a parity constraint: $U_1 \oplus U_4 \oplus U_5 \oplus U_7 \oplus U_8 = 0$.
A codeword is valid only if it respects all the parity constraints defined by
the check nodes.
The LDPC code can be also represented by a \textit{parity check matrix}:
{ \begin{equation*}
H =
\begin{bmatrix}
  1&0&0&1&1&0&1&1\\
  0&1&1&0&0&1&1&0\\
  1&0&1&0&0&1&0&1\\
  0&1&0&1&1&0&1&0
\end{bmatrix}.
\end{equation*}
}
The Min-Sum decoder is an iterative message passing algorithm based on the
Tanner graph representation. Probabilistic messages ($M$) are exchanged between
the variable nodes and check nodes iteratively. Variable nodes and check nodes
apply an \textit{update rule} to compute the outgoing messages from the incoming
messages.
In this section, the Min-Sum update rule is considered as well as an horizontal
layered scheduling.
The original version of the Min-Sum algorithm works on floating-point values,
but it has been shown that fixed-point simplifications have very similar decoding
performance. Moreover, a fixed-point representation enables to pack more
elements into SIMD registers.

\begin{figure}[htp]
\begin{lstlisting}[style = mycpp, caption={LDPC decoder implementation with \MIPP.}, label={lst:LDPC}]
void DecBP(const std::vector<std::vector<int>>   &H
                 std::vector<mipp::Reg<int16_t>> &VN
                 std::vector<mipp::Reg<int16_t>> &M,
                 std::vector<mipp::Reg<int16_t>> &C
           const unsigned                        nIte) {
	constexpr auto N = mipp::nElReg<int16_t>();
	const auto max = std::numeric_limits<int16_t>::max();
	const auto zeroMsk = mipp::Msk<N>(false);
	const auto zero = mipp::Reg<int16_t>(0);
	for (auto i = 0; i < nIte; i++) {
		auto mRead = 0, mWrite = 0;
		for (auto c = 0; c < H.size(); c++) {
			auto sign = zeroMsk;
			auto min1 = mipp::Reg<int16_t>(max);
			auto min2 = mipp::Reg<int16_t>(max);
			for (auto v = 0; v < H[c].size(); v++) {
				C[v] = VN[H[c][v]] - M[mRead++];
				auto cabs = mipp::abs(C[v]);
				auto ctmp = min1;
				sign ^= mipp::sign(C[v]);
				min1  = mipp::min(min1,           cabs       );
				min2  = mipp::min(min2, mipp::max(cabs, ctmp));
			}
			auto cst1 = mipp::blend(zero, min2, zero > min2);
			auto cst2 = mipp::blend(zero, min1, zero > min1);
			for (auto v = 0; v < H[c].size(); v++) {
				auto cval = C[v];
				auto cabs = mipp::abs(cval);
				auto cres = mipp::blend(cst1, cst2, cabs == min1);
				auto csig = sign ^ mipp::sign(cval);
				     cres = mipp::copysign(cres, csig);
				M[mWrite++] = cres;
				VN[H[c][v]] = C[v] + cres;
}	}	}	}
\end{lstlisting}
\end{figure}

\begin{table}[htp]
  \tabcolsep=6pt
  \centering
  \caption{LDPC decoder speedups with \MIPP.}
  \label{tab:sp_ldpc}
  {\small
  \begin{tabular}{r|r|r|r}
                      & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
  \textbf{SIMD size}  & 8                      & 8                     & 16                    \\ \hline
  \textbf{T/P} (Mb/s) & 8.3                    & 30.3                  & 53.2                  \\ \hline
  \textbf{Speedup}    & $\times 9.7$           & $\times 8.8$          & $\times 15.2$         \\
  \end{tabular}
  }
\end{table}

Listing~\ref{lst:LDPC} shows a 16-bit fixed-point LDPC decoder.
This decoder works on several frames at once. Each element of the SIMD registers
corresponds to an element of a specific frame.
This approach is called the \textit{inter-frame} vectorization.
This strategy maximizes decoder throughput at the expense of latency.
Notice that the data type can be switched from \verb|int16_t| to \verb|int8_t|,
\verb|int32_t|, \verb|float| or \verb|double|.
This \MIPP feature is important for digital communication: adapting the data
type without changing the source
code enables to address varying constraints with a single source code.
Table~\ref{tab:sp_ldpc} presents speedups obtained with \MIPP.
Ten iterations are performed and a stop criterion was implemented for the tests
based on parity check constraints (not shown in Listing~\ref{lst:LDPC}).
The $H$ matrix comes from the IEEE 802.3an standard (10Gbps Ethernet).
Speedups are close to the SIMD width. In \verb|NEON| and \verb|SSE| they even
exceed it.
Such result can be explained by an optimized memory management compared to
the sequential version of the code.

\subsection{Polar Codes Decoding}\label{subsec:polar}

\begin{figure}[hbp]
\centering
\includegraphics[width=0.45\textwidth]{figs/tree_representation_SC_decoder}
\caption{Tree representation of the SC polar decoding}
\label{fig:Polar}
\end{figure}

\begin{figure}[htp]
\begin{lstlisting}[style = mycpp, caption={\MIPP implementations of $f$, $g$ and $h$ functions.}, label={lst:Polar}]
mipp::Reg<int8_t> f_simd(const mipp::Reg<int8_t> &la,
                         const mipp::Reg<int8_t> &lb) {
	auto abs_min = mipp::min(mipp::abs(la), mipp::abs(lb));
	auto sign    = mipp::sign(la ^ lb);
	return mipp::neg(abs_min, sign);
}
mipp::Reg<int8_t> g_simd(const mipp::Reg<int8_t> &la,
                         const mipp::Reg<int8_t> &lb,
                         const mipp::Reg<int8_t> &sa) {
	return mipp::neg(la, sa) + lb;
}
mipp::Reg<int8_t> h_simd(const mipp::Reg<int8_t>& sa,
                         const mipp::Reg<int8_t>& sb) {
	return sa ^ sb;
}
\end{lstlisting}
\end{figure}

Polar codes have been introduced by \Arikan in 2008 \cite{Arikan2009}.
They have also been selected as channel codes in the future 5G standard to
improve the reliability of the data control channels.
We present the Successive Cancellation (SC) polar decoding algorithm.
As Min-Sum for LDPC codes, SC decoding is also a message passing algorithm.
Here, messages propagate on a binary tree in a depth-first scheduling.
Figure~\ref{fig:Polar} shows a polar code tree representation. Descending
messages are LLRs, ascending messages are bits. Each node applies an update
rule on the messages. When going down to the left, rule~$f$ is applied;
when going down to the right, rule~$g$ is applied,
when going up, rule~$h$ function is applied:
{
  \begin{eqnarray*}
    \left\{\begin{array}{l c l}
      f(\lambda_a,\lambda_b) &=& sign(\lambda_a.\lambda_b).\min(|\lambda_a|,|\lambda_b|)\\
      g(\lambda_a,\lambda_b,\hat{s}_a)&=&(1-2\hat{s}_a)\lambda_a+\lambda_b\\
      h(\hat{s}_a,\hat{s}_b)&=& (\hat{s}_{a} \oplus \hat{s}_{b}, \hat{s}_{b})
    \end{array}\right.
    \label{eq:f_g}
  \end{eqnarray*}
}
The number of elements to compute per node is halved from one layer to the next.
E.g. in Layer~1, 8~independent elements can be computed in the $f,g,h$ functions
while in the Layer~2, there are only 4~independent elements to compute by node.
Listing~\ref{lst:Polar} presents an 8-bit fixed-point SIMD implementation of
rules $f,g,h$. They compute multiple elements in the same frame to exploit the
\textit{intra-frame} parallelism.
This strategy has a lower throughput than inter-frame strategy but it also a
lower latency.
It is constrained by the decoding algorithm, which has a limited intrinsic
parallelism.
Indeed, at some point in the lowest layers of the tree, there is not enough
parallelism anymore, and sequential $f,g,h$ functions have to be used instead.
As for the LDPC decoder, the data type of the SC decoder can be switched from
\verb|int8_t| to \verb|int16_t|, \verb|int32_t|, \verb|float| or \verb|double|.

\begin{table}[hbp]
  \tabcolsep=6pt
  \centering
  \caption{SC decoder speedups with \MIPP.}
  \label{tab:sp_polar}
  {\small
  \begin{tabular}{r|r|r|r}
                      & \textbf{\texttt{NEON}} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} \\ \hline
  \textbf{SIMD size}  & 16                     & 16                    & 32                    \\ \hline
  \textbf{T/P} (Mb/s) & 148.7                  & 528.3                 & 483.0                 \\ \hline
  \textbf{Speedup}    & $\times 3.1$           & $\times 4.4$          & $\times 3.8$          \\
  \end{tabular}
  }
\end{table}

In typical SC applications, some tree cuts can be applied statically out of the
decoder selected parameters. Such tree cut instances significantly reduce the
number of traversed nodes in the low levels of the tree, where parallelism is
low. Such a tree cut version (Fast-SSC \cite{Giard2014}) has been used for the
experiments presented here.
Table~\ref{tab:sp_polar} shows the obtained speedups.
This time, even if the potential parallelism is high (16 for \verb|NEON| and \verb|SSE|, 32
for \verb|AVX|), the measured speedups does not exceed 4.4, due to the remaining low
parallelism nodes.
Also the sequential implementation of the code has been almost fully
auto-vectorized.
The \verb|SSE| code performs better than the \verb|AVX| one,
because of the nature of the algorithm. Actually, using larger SIMD registers is
good for nodes with enough parallelism, but this reduces the total number of
nodes which can be effectively vectorized.
In these sub-optimal cases, the SIMD loads and stores cannot be aligned anymore
and sometime a sequential code replaces the SIMD implementation.
As a consequence, for the selected codewords, it is more advantageous
to use \verb|SSE| than \verb|AVX|.

\section{Related Works}

Many SIMD programming solutions have been surveyed in \cite{Pohl2016} to
take advantage of modern instruction sets. The existing alternatives can
be decomposed into three main models: 1)~intrinsics or assembly code;
2)~dedicated language; and 3)~dedicated library. The intrinsics or
assembly approaches are non-portable, low-level solutions which target
specific architectures. They offer maximum control to
take advantage of instruction set specificities, and to fine tune
register usage. However, it is quite difficult to develop and maintain a
low-level code in the long run.
Some languages have been designed to provide programmers with
SIMD programming constructs. Many of them are based on general purpose
languages extended with some kinds of annotation mechanism (e.g.
pragmas) such as OpenMP \cite{OpenMP2013}, Cilk Plus \cite{Robison2013} or ispc \cite{Pharr2012}.
They offer higher expressiveness, better portability and generally more
readable code, at the expense of less programmer control,
and vectorization performance.
More specialized languages, such as OpenCL \cite{Howes2015}, enable the
programmer to retain more control, as the counterpart of writing some more
specific code.
In this paper, the focus is given to the library approach since we want
to maximize performance, maximize portability and
deal with existing \Cxx codes. In order to let the compiler inline
library calls, which is critical for the intended SIMD programming model
purpose, such library are usually header-only. Thus, we refer to them as
\textit{wrappers} instead of \textit{libraries}.

\subsection{\Cxx SIMD Wrappers}

\begin{table*}[htp]
  \renewcommand{\arraystretch}{0.95}
  \tabcolsep=6pt
  \centering
  \caption{Comparison of various SIMD wrappers.}
  \label{tab:comp}
  {\small\resizebox{\linewidth}{!}{
  \begin{tabular}{|r|r|r|r|r||c|c|c|c|c||c|c|c|c|c|c||c|c|c|}
  \hline
  \multicolumn{5}{|c||}{\multirow{2}{*}{\textbf{General Information}}}                                                               & \multicolumn{5}{c||}{\multirow{2}{*}{\textbf{Instruction Set}}}                                                                & \multicolumn{6}{c||}{\multirow{2}{*}{\textbf{Data Type}}}                    & \multicolumn{3}{c|}{\multirow{2}{*}{\textbf{Features}}} \\
  \multicolumn{5}{|c||}{}                                                                                                            & \multicolumn{5}{c||}{}                                                                                                         & \multicolumn{6}{c||}{}                                                       & \multicolumn{3}{c|}{}                                  \\ \hline
  \multicolumn{2}{|r|}{\textbf{Name}}                                      & \textbf{Ref.}       & \textbf{Start} & \textbf{License} & \textbf{\texttt{SSE}} & \textbf{\texttt{AVX}} & \textbf{\texttt{AVX-512}} & \textbf{\texttt{NEON}} & \textbf{\texttt{AltiVec}} & \multicolumn{2}{c|}{\textbf{Float}} & \multicolumn{4}{c||}{\textbf{Integer}} & \textbf{Math}  & \textbf{\Cxx}      & \textbf{Test}    \\ \cline{11-16}
  \multicolumn{2}{|r|}{}                                                   &                     & \textbf{Year}  &                  & 128-bit               & 256-bit               & 512-bit                   & 128-bit                & 128-bit                   & 64      & 32                        & 64     & 32     & 16     & 8           & \textbf{Func.} & \textbf{Technique} & \textbf{Suite}   \\ \hline \hline
  \multirow{8}{*}{\rotatebox[origin=c]{90}{\textbf{Library}}} & \MIPP      & $-$                 & 2013           & MIT              & \cmark                & \cmark                & \cmark                    & \cmark                 & \xmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Op. overload.      & \cmark           \\ \cline{2-19}
                                                              & \VCL       & \cite{Fog}          & 2012           & GNU GPL          & \cmark                & \cmark                & \cmark                    & \xmark                 & \xmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Op. overload.      & \textbf{N/A}     \\ \cline{2-19}
                                                              & \simdpp    & \cite{Kanapickas}   & 2013           & Boost Software   & \cmark                & \cmark                & \cmark                    & \cmark                 & \cmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \xmark         & Expr. templ.       & \cmark           \\ \cline{2-19}
                                                              & \TSIMD     & \cite{Moller2016}   & 2016           & Open-source      & \cmark                & \cmark                & \xmark                    & \cmark                 & \xmark                    & \xmark  & \cmark                    & \xmark & \cmark & \cmark & \cmark      & \xmark         & Op. overload.      & \textbf{N/A}     \\ \cline{2-19}
                                                              & \Vc        & \cite{Kretz2012}    & 2012           & BSD-3-Clause     & \cmark                & \cmark                & \xmark                    & \xmark                 & \xmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \xmark      & \cmark         & Op. overload.      & \cmark           \\ \cline{2-19}
                                                              & \xsimd     & \cite{Mabille}      & 2014           & BSD-3-Clause     & \cmark                & \cmark                & \xmark                    & \xmark                 & \xmark                    & \cmark  & \cmark                    & \cmark & \cmark & \xmark & \xmark      & \cmark         & Op. overload.      & \textbf{N/A}     \\ \cline{2-19}
                                                              & \BoostSIMD & \cite{Esterie2012}  & 2012           & Boost Software   & \cmark                & \xmark                & \xmark                    & \xmark                 & \xmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Expr. templ.       & \cmark           \\ \cline{2-19}
                                                              & \bSIMD     & \cite{Esterie2012a} & 2017           & Non-free         & \cmark                & \cmark                & \cmark                    & \cmark                 & \cmark                    & \cmark  & \cmark                    & \cmark & \cmark & \cmark & \cmark      & \cmark         & Expr. templ.       & \cmark           \\ \hline
  \end{tabular}
  }}
\end{table*}

\begin{figure*}[htp]
\centering
\includegraphics[width=0.90\textwidth]{plots/mandelbrot_speedup}
\caption{Speedups over the Mandelbrot naive auto-vectorized implementation}
\label{fig:fractal}
\end{figure*}

Table~\ref{tab:comp} compares various SIMD wrappers. It aims to
present an overview of some prominent solutions, though it
is by no means exhaustive due to the richness of the SIMD wrapper
landscape. Some of the wrappers presented, such as \MIPP,
\Vc, \BoostSIMD, \VCL and \TSIMD, have been
designed in an academic research context. Some others, \simdpp and
\xsimd, appear to be standalone development efforts by individual
programmers or maintainers. Proprietary, closed-source solutions also
exist on the market, such as \bSIMD, which is an extended version
of \BoostSIMD, or the commercial version of \VCL.
The \textit{Instruction Set} column is broken up into five families among the
most widely available on the market: \verb|NEON|, \verb|SSE|, \verb|AVX|, \verb|AVX-512| and
\verb|AltiVec|. For the sake of conciseness, we choose not to list all the instruction sets ``sub-variants''
(such as \verb|SSE2|, \verb|SSE3|, etc). \simdpp et \bSIMD
propose the most comprehensive instruction set compatibility. At the
other end of the range, \xsimd and \BoostSIMD only support
Intel SIMD instruction sets. The \textit{Data Type} column of the table
summarizes the supported vector element types and precisions. In their
public version, and at the time of writing, \Vc does not support
8-bit integers, \xsimd does not support 8-bit and 16-bit integers
and \TSIMD does not support 64-bit data types, to the best of our
knowledge. The \textit{Features} column highlights some additional characteristics.
The \textit{Math Func.}~ column indicates which wrapper supports additional mathematical
sub-routines, not necessarily available as native CPU instructions (exponential,
logarithm, trigonometric functions for instance), and required by algorithms
such as the Box-Muller Transform (see Section~\ref{subsec:bmt}). The \textit{\Cxx
Technique} column indicates whether the wrapper is designed as an expression template framework, or whether it relies on operator overloading techniques.
The expression template feature is a powerful technique to automatically drive
the rewriting of whole arithmetic expressions into SIMD hardware instructions
or instruction sequences. For instance if the user writes \verb|d = a * b + c|,
the wrapper can automatically match a \emph{fused multiply and add} instruction
(FMA). \BoostSIMD and \bSIMD extensively use this technique~\cite{Esterie2012,Esterie2012a}.
The drawbacks are that the source code complexity of the wrapper is dramatically increased.
\BoostSIMD and \bSIMD have a dependency on the Boost framework to
build, and currently available \Cxx compilers produce huge amounts of arcane
error messages at the slightest mistake in the end user program.
For these reasons, we decided not to base \MIPP on the expression template technique.
As mentioned in Section~\ref{subsec:implem}, maintaining SIMD wrappers, and porting
them to new instruction sets is error prone by nature, due to the large number
of routines, cryptic intrinsics names, and specific instruction set details.
A comprehensive testing suite is therefore critical to validate new
development, optimizations and ports on new instruction sets. This is why
\MIPP, as well as \Vc, \BoostSIMD, \simdpp and \bSIMD
come with their own test suites. We have not found similar test suites in the
software distributions of \VCL, \xsimd and \TSIMD; however, test
suites might be in use internally, within the development teams of these wrappers.

\subsection{Qualitative and Quantitative Comparisons}

We now compare \MIPP with the open-source
wrappers presented above, both qualitatively for our error correction
code purpose, and quantitatively on a well known benchmark the
computation of the Mandelbrot set, to prevent as much as possible the
risk of unfairness of the port on each wrapper. This problem is compute-bound.
The chosen implementation relies on a floating-point representation
(available online\footnote{Mandelbrot set source code: \url{https://gitlab.inria.fr/acassagn/mandelbrot}}).
Figure~\ref{fig:fractal} presents the speedups obtained on various
instruction sets. \verb|SSE| stands for \verb|SSE4.2|, \verb|NEON|
stands for \verb|NEONv2| (includes the FMA instructions), \verb|AVX|
stands for \verb|AVX2+FMA3| and \verb|AVX-512| stands for
\verb|AVX-512F| (with FMA instructions).
The \verb|FMA| benefit ranges from 17\% (\verb|AVX2|) to 26\%
(\verb|AVX-512|).
An SIMD with intrinsics version has been hand-coded for each
specific instruction set. The intrinsics version is considered the
``\emph{golden}'' model.

\textbf{\BoostSIMD} only supports the \verb|SSE| instruction set, even
when the code is compiled with one of the \verb|AVX| or \verb|AVX-512|
flags. It is insufficient for our channel coding processing purpose.
The \BoostSIMD wrapper performance results that were obtained are
disappointing. The sequential Mandelbrot kernel does an early exit in
the innermost loop, as soon as the divergence of the sequence is
detected for the input coordinates. We were unable to SIMDize this
early termination with \BoostSIMD, because the \verb|boost::simd::any|
function was not available in the GitHub repository at the time of
writing.
\textbf{\xsimd} achieves performance close to the intrinsic version in \verb|SSE| and \verb|AVX|.
However, it currently lacks \verb|NEON| and \verb|AVX-512| support. Moreover, it
does not support small 8-bit and 16-bit integers, needed for Successive
Cancellation decoders (see Section~\ref{subsec:polar}).
\textbf{\Vc} is one of the earliest developed SIMD \Cxx wrapper. We used
Branch~1.3 for the performance measurements, the latest stable branch at
this time. \Vc includes a lot of of features compared to the other
wrappers; but it lacks support for \verb|NEON| and \verb|AVX-512| (which are currently
being developed). Performance results are on par with the best contenders for \verb|AVX|.
However, a slowdown is observed for \verb|SSE|. Note: For \verb|AVX-512|, since the support
is not yet available in the stable version, we used the capability of
\Vc to generate \verb|AVX2| code in order to produce the sample points for
\verb|AVX-512| series. The results are likely to improve once the full \verb|AVX-512|
support is release in a subsequent stable version.
\textbf{\TSIMD} is a wrapper primarily designed for image processing purpose.
It performs well in 32-bit \verb|NEON|, \verb|SSE| and \verb|AVX| but it lacks from \verb|AVX-512|.
Support of the 64-bit types is not planed since it is not useful in traditional image computations.
\textbf{\simdpp} supports an impressive number of instruction sets. This may
explain why it does not support mathematical functions so far. It matches the
performance of the other wrappers for \verb|NEON| and \verb|SSE|, but falls behind for
\verb|AVX|, and even more for \verb|AVX-512|.
\textbf{\VCL} is a high performance wrapper and perhaps the most feature rich for
x86 SIMD at this time. It gives a lot of control to the developer and it
is well documented. The obtained performance are on the same level as
hand-written intrinsics. However, it is not yet available on \verb|NEON|.
For \MIPP we have tested both the lower-level programming
interface and the medium-level programming interface of our \MIPP
wrapper, mainly to detect potential overheads when using the medium level interface
instead of the lower one. The obtained results do not show any performance
penalties when using \MIPP medium level interface.
The obtained speedups are close to the intrinsics version.

\MIPP corresponds to a programming model close to the intrinsics, with
some adaptation to architectures. Still, a high performance code
requires that the developer knows how to decompose efficiently some
computation with the SIMD instructions. Between \verb|AVX-512| and \verb|SSE| or
\verb|NEON| for instance, several implementations of the same code are possible.
\MIPP offers to the programmer the control on the intrinsics taken and ensures
portability.

\section{Conclusion}

This paper introduces \MIPP, a \Cxx wrapper for SIMD intrinsics. It is
designed to fit recent digital communication algorithms, especially channel
decoding algorithms such as LDPC or Polar code methods. It offers high portability: the same code
can be compiled on different target architectures and still offer
high performance, adapted for both simulation of channel decoding on
high-end machines and embedded software decoding. The decoding accuracy
is set simply by choosing the vector element types used as template
parameters. Despite its application-oriented design, \MIPP
shows state-of-the-art performance on the Mandelbrot generation algorithm.

As future works, we plan to wrap the new ARM
\textit{Scalable Vector Extension} (\verb|SVE|)~\cite{Stephens2017}, a
vector-length agnostic architecture, thus the main challenge
will be to deal with unknown vector sizes at compile time. However, the
philosophy of \verb|SVE| somewhat coincides with \MIPP's: a same code can
accommodate and mix various vector sizes. Moreover, \MIPP's masks would
likely map on \verb|SVE|'s predicate registers straight away.

\begin{small}
\begin{acks}
  The authors would like to thank Mathieu L\'eonardon for providing
  advices and a comprehensive review on this paper.
  Experiments presented in this paper were carried out using the PLAFRIM
  experimental testbed.
\end{acks}
\end{small}

\bibliographystyle{ACM-Reference-Format}
\bibliography{article.bib}

\end{document}